/**
  ******************************************************************************
  * @file    audio_in_task.c
  * @author  MK
  * @version V0.1
  * @date    08/01/2021
  * @brief   Audio IN task
  ******************************************************************************
  */

/* Kernel includes. */
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

#include <stdio.h>
#include <string.h>
#include "audio_in_task.h"
#include "adc.h"

#define	AUDIO_IN_TASK_PRIORITY		(tskIDLE_PRIORITY + 1L)
#define AUDIO_IN_TASK_STACK_SIZE	configMINIMAL_STACK_SIZE
#define AUDIO_IN_TASK_PERIOD		1000

void audioInLoop(void)
{
	portTickType xLastWakeTime;
	xLastWakeTime = xTaskGetTickCount();

	while(1) {
		vTaskDelayUntil(&xLastWakeTime, AUDIO_IN_TASK_PERIOD);
		ADC_Status();
	}
}

static void audioInTask(void* pvParameters)
{
	ADC_Init();
	audioInLoop();
}

void vStartAudioInTask( void )
{
	xTaskCreate(audioInTask, "AudioIn", AUDIO_IN_TASK_STACK_SIZE, NULL, AUDIO_IN_TASK_PRIORITY, NULL);
}

